#include "NetUsage2.h"


NetUsage2::NetUsage2() {
    fs=NULL;
    mgr=NULL;
    bl=NULL;
    sm=NULL;
    gap=NULL;

}
NetUsage2::NetUsage2(int nlinks, int nslots, double grid, int guard_band)
{
    fs=NULL;
        mgr=NULL;
        bl=NULL;
        sm=NULL;
        gap=NULL;
        fillZeros(nlinks, nslots,grid,guard_band);

}
void NetUsage2::fillZeros(int nlinks, int nslots,double grid, int guard_band)
{
    m_netUtil = 0;
    m_specEf = 0;
    m_idxPathAlloc=-1;
    m_specAlloc=0;
    m_pathAlloc.clear();
    m_hopAlloc=0;

    m_nlinks = nlinks;
    m_nslots = nslots;
    m_ls = m_nlinks* m_nslots;
m_grid=grid;
m_GB=guard_band;
    m_netUsage.resize(m_nslots);

    {
        for (int i = 0; i < m_nslots; ++i)//dla kazdej kolumny
        {
            m_netUsage[i].resize(m_nlinks);
            for(int j=0 ; j< m_nlinks; ++j)////dla kazdego wiersza
            {
                m_netUsage[i][j]=0;
            }
        }
          }
}


double NetUsage2::getNetUtil()
{

   // double ru=  (double) m_netUtil/m_ls;
    return m_netUtil;
}

int NetUsage2::getIdxPathAlloc()
{
    return m_idxPathAlloc;
}
 vector<bool> NetUsage2:: getVecPathAlloc()
 {
     return m_pathAlloc;
 }
 void NetUsage2:: clearPath(){
     m_pathAlloc.clear();
 }

 int NetUsage2::hopAlloc()
 {
     int tmp=m_hopAlloc;
     m_hopAlloc=0;
     return tmp;
 }

double NetUsage2::getSpecEf()
{
    return m_specEf;
}
int NetUsage2:: getSpecAlloc()
{
    return m_specAlloc;
}

void NetUsage2::setZeroEf()
{
    m_specEf=0;
    m_specAlloc=0;


       for(int i=0; i<4; ++i)
       {
           m_tab[i]=0;
           m_tab2[i]=0;    }

   }
    long NetUsage2::getTab(int i)
    {
        return m_tab[i];
    }
   long NetUsage2::getTab2(int i)
   {
       return m_tab2[i];
   }

bool NetUsage2::disconnectId(int id)
{
    bool released = false;
    for (int i = 0; i < m_nslots; ++i)
    {
        for (int j = 0; j < m_nlinks; ++j)
        {
            if (m_netUsage[i][j] == id)
            {
                m_netUsage[i][j] = 0;
                m_netUtil--; //zmniejszenie parametru wykorzystania o kazdy zwolniony slot

                released = true;
            }
        }
    }
    if (!released)
    {
        cerr << "Request id not found "<< id;

    }

    return released;

}

int NetUsage2::checkFree(vector<bool> pathSD, int resources)
{
    bool is_resevable = false;

    int i;
    int sum = 0;
    for (i = 0; i < m_nslots; ++i)
    {
        sum++;
        for (int j = 0; j < m_nlinks; ++j)
        {

            if (pathSD[j] == true && m_netUsage[i][j] != 0)
            {
                sum = 0;
                break;
            }
        }
        if (sum == resources)
        {
            is_resevable = true;
            break;
        }
    }
    if (is_resevable == true)
    {
        return i - (resources - 1); // returned idx of rows from alloc will start
    }
    else
    {
        cerr<< "error with startIdx11"<<endl;
            exit (1);
        //return m_nslots;
    }
}

void NetUsage2::alloc(vector<bool> pathSD, int resources, int startIdx, int id)
{
    if(startIdx==m_nslots)
    {
    cerr<< "error with startIdx"<<endl;
    exit (1);
    }
    m_pathAlloc= pathSD;//ustawienie wektora sciezki alokacji
    for (int i = 0; i < resources; ++i)
    {
        for (int j = 0; j < m_nlinks; ++j)

        {
            if (pathSD[j] == true && m_netUsage[startIdx + i][j]!=0 ) //tutaj sprawdzam zeby mi nie nadpisywal, je���li bym zle policzyla
            {
                cerr<< "error with idx444 allocation "<<endl;
                exit (1);
            }
            if (pathSD[j] == true &&m_netUsage[startIdx + i][j]==0)
            {
                m_netUsage[startIdx + i][j] = id;
                m_netUtil++;//zwiekszenie m_netUtili z kazdym zajetym slotem
                m_specAlloc++;//zwiekszam wykorzystanie spektrum
            }


        }
    }
}

//sprawdz sukces alokacji RSMA dla jednej sciezki//mozna sprawdzac cykliczna sciezke z bestFit/maxUsage/firstFit
bool NetUsage2::checkAllocPath(PathSD path, double bw, int id)
{
    //if (checkFree(path.getVec(), path.getModul()*resources+1) == m_nslots)
          //double resources2=(double)resources;
            int numReq = (int) ceil(bw/(path.getModul()*m_grid))+m_GB;

       //if (bestFitSlot(path.getVec(), numReq)==m_nslots) //tu juz przeliczona modulacja
        if( existFreeForReq(path.getVec(),numReq)==false)
{

           return false;

       }

       else

       {
           m_pathAlloc=path.getVec(); //ustawienie sciezki i hop alokacji
           m_hopAlloc=path.getHops();
           m_specEf=m_specEf +bw/numReq;

        int startIdx=bestFitSlot(path.getVec(),numReq);
           alloc(path.getVec(), numReq,startIdx,id);
           return true;


       }
}

//---SPRAWDZENIE ZASOBOW SIECI//
bool NetUsage2::existFreeForReq(vector<bool> pathSD, int numReq)
{
    vector<int> sumUsage;
    sumUsage.resize(m_nslots);
    int i;
    int sumZero=0;
    for ( i = 0; i < m_nslots; ++i) //dla danej kolumny
    {

        for (int j = 0; j < m_nlinks; ++j) //dla kazdego SingleFiber dla ktorego pathSD=1
        {

            if (pathSD[j] == true)
            {
                sumUsage[i] += m_netUsage[i][j];
            }
        }

    }
    vector<int>::iterator iter;
    iter = search_n(sumUsage.begin(),sumUsage.end(), numReq,0);
    if (iter-sumUsage.begin() < sumUsage.size())
    {

        return true;
    }
    return false;
}

//---obliczenia BlockSet--//
void NetUsage2::setFreeForReq(vector<bool> pathSD, int numReq)
{
    fs=new BlockSet;
    vector<int> sumUsage;
    sumUsage.resize(m_nslots);

    for ( int i = 0; i < m_nslots; ++i) //dla danej kolumny
    {

        int sumTmp = 0;
        for (int j = 0; j < m_nlinks; ++j) //dla kazdego SingleFiber dla ktorego pathSD=1
        {

            if (pathSD[j] == true)
            {
                sumTmp += m_netUsage[i][j];
            }
        }
        if (sumTmp != 0)
        {
            sumUsage[i] = 1;
        }

        if (sumTmp == 0)

        {
            sumUsage[i] = 0;

        }

    }

    //tuZERUJE MODULACJE!!
    fs->setBlockForReq(pathSD, numReq,sumUsage,0);
}


//--ALG First Path First fit --//

int NetUsage2::firstFitSlot(vector<bool> pathSD,int numReq)
{
    setFreeForReq(pathSD,numReq);
    if (fs->sizeSet()>0)
    {
      
        return fs->firstBlock();
    }
    return m_nslots;
}








int NetUsage2::bestFitSlot(vector<bool> pathSD, int numReq)
{
    setFreeForReq(pathSD, numReq);
    if( fs->sizeSet()>0 )
    {
        return fs->bestFirst();
    }
    return m_nslots;
}






//
//int NetUsage2::searchFreeSlot(vector<bool> pathSD, int numReq)
//{
//    vector<int> sumUsage;
//    sumUsage.resize(m_nslots);
//    int i;
//    int sumZero=0;
//    for ( i = 0; i < m_nslots; ++i) //dla danej kolumny
//    {
//
//        for (int j = 0; j < m_nlinks; ++j) //dla kazdego SingleFiber dla ktorego pathSD=1
//        {
//
//            if (pathSD[j] == true)
//            {
//                sumUsage[i] += m_netUsage[i][j];
//            }
//        }
//
//    }
//    vector<int>::iterator iter;
//    iter = search_n(sumUsage.begin(),sumUsage.end(), numReq,0);
//    if (iter-sumUsage.begin() < sumUsage.size())
//    {
//
//        return iter-sumUsage.begin();
//    }
//    else
//    {
//        return m_nslots;
//    }
//
//}

double NetUsage2::numUsedLP (vector<bool> pathSD)
{
    vector<int> LP=getSumFiberSD(pathSD);
           double numU=0;
    for(int i=0; i<m_nslots; ++i)
        {
       numU=+LP[i];
               }
    return numU;
}

double NetUsage2::numFreeLP(vector<bool> pathSD)
{
     double numFree= m_nslots-numUsedLP(pathSD);

        return numFree;
}
//-------------------------------------------------------------------//
vector <int> NetUsage2:: getSumFiberSD( vector<bool> pathSD)

{
    vector<int> sumUsage;
    sumUsage.resize(m_nslots);

    for (int i = 0; i < m_nslots; ++i) //dla danej kolumny
    {
        int sumTmp = 0;
        for (int j = 0; j < m_nlinks; ++j) //dla kazdego SingleFiber dla ktorego pathSD=1
        {

            if (pathSD[j] == true)
            {
                sumTmp += m_netUsage[i][j];
            }
        }
        if (sumTmp != 0)
        {
            sumUsage[i] = 1;
        }

        if (sumTmp == 0)

        {
            sumUsage[i] = 0;

        }
       // cout<< sumUsage[i];
    }
    //cout<<endl;
    return sumUsage;
}

vector<vector<int> > NetUsage2:: get_pathLinksUsage ( vector<bool> pathSD)
{
    vector<vector<int> > tmp;

    for(int j=0; j<m_nlinks;++j)
    {

        if(pathSD[j]==true)
        {

            tmp.push_back(getColumn(j));

        }

    }
    return tmp;
}

vector<int> NetUsage2::row(int idx)
{

    return m_netUsage[idx];
}

vector<vector<int> > NetUsage2::getRows(int startIdx, int numS)
{
    vector<vector<int> > ret;
    for(int i=0; i<numS;++i)
    {
        ret.push_back(m_netUsage[startIdx+i]);
    }
    return ret;
}

vector<int> NetUsage2::getColumn(int j)
{
    vector <int>ret;
    ret.resize(m_nslots);
    for (int i=0; i<m_nslots; ++i)
    {
        ret[i]=m_netUsage[i][j];
    }
    return ret;
}
void NetUsage2::setElement(int i , int j, int val)
{
    m_netUsage[i][j]=val;

}
int NetUsage2::getElement(int i , int j)
{
    return m_netUsage[i][j];
}

int NetUsage2::sumRows(int col)
{
    int ret = 0;
    for (int i=0; i< m_nslots; ++i)
    {
        ret +=m_netUsage[i][col];
    }
    return ret;
}

bool NetUsage2::freeFiber(int col)
{
    for (int i=0; i< m_nslots; ++i)
    {
        if (m_netUsage[i][col]!=0)
        {
            return false;
        }
        return true;
    }
}
//
////do edgeFit--//
//int NetUsage2::calcHeadFit(vector< bool> pathSD, int startIdx)
//{
//    int headFit=0;
//    if (startIdx==0)
//    {
//        return headFit;
//    }
//    if (startIdx!=0)
//    {
//        for(int j =0; j<m_nlinks; ++j) //dla ka���dego ������cza sciezki
//        {
//            if (pathSD[j]==true)
//            {
//                headFit+=countToStart(startIdx,j);
//
//            }
//        }
//    }
//    return headFit;
//}
//
//int NetUsage2::countToStart(int startIdx,int col)
//{
//    int ret_lIdx=0;
//    /*if (startIdx==0)
//    {
//    ret_lIdx=0;
//    }*/
//    for(int i=startIdx-1; i>=0; --i)
//    {
//        if (m_netUsage[i][col]!=0) //pathLink[start-1]
//        {
//            break;
//        }
//
//        if (m_netUsage[i][col]==0)
//        {
//            ret_lIdx++;
//        }
//
//    }
//    return ret_lIdx;
//
//}
//

//-----------------------//
bool NetUsage2::unuseSlot(int idx)
{
    for(int i=0; i< m_nlinks;++i)
    {
        if (m_netUsage[idx][i]!=0)
        {
            return false;
        }
    }

    return true;

}
int NetUsage2::countFreeSlotInNet()
{
    int numUnused=0;
    for (int i=0; i<m_nslots; ++i)
    {
        if(unuseSlot(i)==true)
            numUnused++;
    }
    return numUnused;
}
double NetUsage2::usageSlotPerLink(int idx)
{
    double usageS=0;
    for (int i =0; i<m_nlinks;++i)
    {
        if (m_netUsage[idx][i]!=0)
        {
            usageS++;
        }
    }
    double perLink=usageS;
    return perLink;
    /*double perLink=usageS/m_nlinks;
    return perLink;*/
}

double NetUsage2::usageBlockPerLink(int start, int numS)
{
    double usageBlock=0;
    for(int i=start ;i<start+numS; ++i)
    {


        usageBlock += usageSlotPerLink(i);
    }
    return usageBlock;
    //return usageBlock/numS;
}

int NetUsage2::cFreeSlotInBlock(int start, int numS)
{
    int sumUnused=0;
    for (int i=start; i<start+numS; ++i)
    {
        if (usageSlotPerLink(i)==0)

        {
            sumUnused++;
        }
    }
    return sumUnused;

}

//-----------------------//
void NetUsage2::showMatrix() const
{
    cout<<endl;
    for (int i = 0; i < m_netUsage.size(); ++i)
    {
        for (int j = 0; j < m_netUsage[i].size(); ++j)
        {
           cout<< m_netUsage[i][j]<<"   ";
        }
      cout<<" koniec wiersza " << endl;

    }
    cout<<endl;
    cout<<endl;

}


//-------------------------------------------------------------------------------------------------------------//




NetUsage2::~NetUsage2() {
    delete fs;
     delete bl;
    delete mgr;
    delete sm;
    delete gap;
    ;}


