#include "SingleLink.h"

SingleLink::SingleLink() {}

/*void  SingleLink:: setLink( int in, int out, int len, double maxtraffic,double thereshold)
{
    // m_idLink=idLink;
    m_idtraffic.resize(1,0);
    m_in=in;
    m_out=out;
    m_phyLen=len;
    m_maxtraffic=maxtraffic;
    m_alltraffic=0;
    m_trafficCongested=thereshold*maxtraffic;
}*/
void  SingleLink:: setLink( int in, int out, int len, double maxtraffic,double thereshold)
{
    // m_idLink=idLink;
    m_idtraffic.resize(1,0);
    m_in=in;
    m_out=out;
    m_phyLen=len;
   if (m_phyLen <= 1200) //dlugosc sciezki modulacja dla BW slotu=12.5 GHz
               {
        m_maxtraffic = 50*maxtraffic; // 16-QAM
       }

       if (m_phyLen <= 2400 && m_phyLen > 1200) {
           m_maxtraffic = 37.5*maxtraffic; //8-QAM
       }

       if (m_phyLen <= 4800 && m_phyLen > 2400) {
           m_maxtraffic = 25*maxtraffic; //QPSK
       }

       if (m_phyLen> 4800 && m_phyLen <= 9600) {
           m_maxtraffic = 12.5*maxtraffic; //BPSK
       }

        if (m_phyLen>9600)
        {
            cerr<< "two long linkIP "<<endl;
                 exit(1);
        }
   //m_maxtraffic=maxtraffic*12.5;

    m_alltraffic=0;
    m_trafficCongested=thereshold*m_maxtraffic;
}

void SingleLink::setLoad(double load)
{
    m_alltraffic=load*m_maxtraffic;
}
bool SingleLink:: emptylink(){
    if (m_idtraffic.size()==1 && m_idtraffic[0]==0)
        return true;
    return false;
}

void SingleLink::addFlow(double rate,int id)
{
   if ( allocatedIPLink(rate)==true)
    m_alltraffic= m_alltraffic + rate;
    if(emptylink()==true)
    {
        m_idtraffic[0]=id;
    }
    else
    {
        m_idtraffic.push_back(id);
    }

    if (m_alltraffic>m_maxtraffic)
    {
        cerr<< "error with calculation of link traffic. Link capacity is bigger than max "<<endl;
        exit (1);
    }

}

bool SingleLink::allocatedIPLink(double rate)
{
if(m_alltraffic==m_maxtraffic){
    return false;
}
 double tmpRate=m_alltraffic+rate;
    if (m_maxtraffic>=tmpRate)
    { return true;}
    else  return false;
}

bool SingleLink::existFlow(int id)
{
    for(int i=0; i<m_idtraffic.size();++i)
    {  if(m_idtraffic[i]== id)
    return true;
    }
    return false;
}

void SingleLink::removeFlow(double rate,int id)
{
    m_alltraffic=m_alltraffic-rate;
    if (m_alltraffic<0)
    {
        cerr<< "error with flows of link ujemne m_alltraffic"<<endl;
        exit (1);
    }

    if (m_idtraffic.size()==1 )
    {
        m_idtraffic[0]=0;

        if (m_alltraffic!=0)
        {
            cerr<< "error with bit rate of link. po remove znajdujacego sie tylko jednego flow m_alltraffic!=0 "<<endl;
            exit (1);
        }
    }

    else{
        int idx;
        int i;
        for( i=0; i<m_idtraffic.size(); ++i)
        {
            if (m_idtraffic[i]==id)

                break;
        }
        idx=i;
        // cout<< "single link przed remove: " ;
        //showFlows();
        m_idtraffic.erase(m_idtraffic.begin()+idx);
        // cout<< "single link po remove: " ;
        //showFlows();
    }
}


bool SingleLink::terminateFlowId(double rate,int id)
{
    bool ret;
    if( existFlow(id)==true)
    {
        removeFlow(rate,id);
            ret=true;
    }
    else
    {   cerr<<"brak takiego flow"<<endl;
    exit(1);
    ret=false;
    }
    return ret;
}


int SingleLink::getInLink(){
    return m_in;
}

int SingleLink::getOutLink(){
    return m_out;
}

int SingleLink::getLengthLink()
{
    return m_phyLen;
}

//bool SingleLink::congested(double rate)
//{
    //if ((m_alltraffic+rate)>  m_trafficCongested)

    bool SingleLink::congested()
    {
        //if ((m_alltraffic+rate)>  m_trafficCongested)
    if (m_alltraffic >=  m_trafficCongested)
        return true;

    else
        return false;
}

double SingleLink::getActualTraffic()
{
    return m_alltraffic;
}

double SingleLink::getMaxTraffcIP()
{
    //return m_trafficCongested;
    return m_maxtraffic;
}

void SingleLink::showFlows()
{
    for(int i=0; i<m_idtraffic.size(); ++i)
    {
        cout<<  m_idtraffic[i]<<"   ";
    }

}

void SingleLink::showTraffic(){
   cout<< "m_maxtraffic: "<< m_maxtraffic<< " "<< "m_alltraffic: "<< m_alltraffic<<endl;
}

SingleLink::~SingleLink() {}
