 #include "Block.h"
using namespace std;

Block::Block(){};
Block::Block(int idxStart,int size)
{
	m_idxStart=idxStart;
	m_size=size;
	m_usageB=0;
	m_numFree=0;
	m_head=0;
	m_tail=0;
	m_mod=0;
}


Block::Block(int idxStart, int size, vector<bool> path, int m)
{
	m_idxStart=idxStart;
	m_size=size;
	m_path=path;
	m_mod=m;
	m_usageB=0;
	m_numFree=0;
	m_head=0;
	m_tail=0;
}
Block:: Block(int idxStart, int size, int usageB, int numFree, vector<bool> path, int m)
{
	m_idxStart=idxStart;
	m_size=size;
	m_usageB=usageB;
	m_numFree=numFree;
	m_head=0;
	m_tail=0;
	m_path=path;
	m_mod=m;
}
//Block::Block (Block &src)

void Block::setUsageB(int usageB)
{
	m_usageB=usageB;
}
void Block::setNumFree(int numFree)
{
	m_numFree=numFree;
}
void Block::setHead(int head)
{
	m_head=head;
}
void Block::setTail(int tail)
{
	m_tail=tail;
}

void Block::setBlockModul(int m)
{
	m_mod=m;
}

int Block::blockModul()
{
	return m_mod;
}
int Block::sizeB()
{
	return m_size;
}
int Block::idx()
{
	return  m_idxStart;
}
int Block::idxEnd(){
	return m_idxStart+m_size-1;
}
int Block::usageB(){
	return m_usageB;
}
int Block::numFreeB()
{
	return m_numFree;
}
int Block::headB()
{
	return m_head;
}
int Block::tailB()
{
	return m_tail;
}

int Block::sumHeadTail()
{
	int sum = m_head + m_tail;
	return sum;
}

int Block::minEdge()
{
    if (m_head!=m_tail)
    {

        return min(m_head, m_tail);
    }
    return m_head;
}

int Block::edgeAlloc(int numReq)
{
    if (m_head > m_tail) //kiedy w bloku glowa bardziej niedopasowana to zwroc start alokacje ogona
    {
        return m_idxStart+m_size-numReq;

    }
    else
        return m_idxStart; //gdy <=
}

vector<bool> Block::blockPath()
{
	return m_path;
}
int Block::hopBlock()
{
	int hopCounter=0;
	for(int i=0;i< m_path.size(); ++i)
	{
		if (m_path[i]>0)
		{
			hopCounter++;
		}
	}
	return hopCounter;
}

//--------------------------//
void Block::displayBlock(){
	cout << m_idxStart << " " <<  m_size << " " << m_usageB<<" " << m_numFree<< " "<<m_head<< " " <<m_tail<< " " << m_mod << endl;
	cout<<endl;
}

void Block::incrSize()
{
	m_size++;
}
bool Block::isEnought(int numReq)
{
	if (m_size>= numReq)
	{
		return true;
	}
	else
		return false;
}
bool Block::isBest(int numReq)
{
	if (m_size == numReq)
	{
		return true;
	}
	return false;
}
bool Block::operator < (const Block &b)const
{
	return m_size <b.m_size;
}

//------------------------//
void Block::calParam(vector<vector<int > > netU)
{
	int usageB=0;
	int usageSbyLinks=0;
	int free=0;
	for(int i=0; i<m_size; ++i) //dla calego bloku
	{

		for (int j=0; j<netU[i].size();++j)//dla kazdego linku
		{
			if (netU[i][j]!=0)
			{
				usageSbyLinks++;
			}
		}
		if (usageSbyLinks==0)
		{
			free++;
		}
		if (usageSbyLinks!=0)
		{
			usageB=usageB+usageSbyLinks;
			usageSbyLinks=0;
		}

	}

	setUsageB(usageB);
	setNumFree(free);

}
int Block::calcHeadBlock(vector<int >  pathLink)
{
	int headFit=0;
	if (m_idxStart==0)
	{
		return headFit;
	}
	if (m_idxStart!=0)
	{
		for (int j= m_idxStart-1; j>=0; --j)
		{
			if (pathLink[j]!=0) //pathLink[start-1]
			{
				break;
			}

			if (pathLink[j]==0)
			{
				headFit++;
			}

		}
		return headFit;
	}

}
int Block::calcTailBlock(vector<int > pathLink)
{
	int tailFit=0;
	if(m_idxStart+m_size-1==pathLink.size()-1)
	{
		return tailFit;
	}
	if (m_idxStart + m_size-1<pathLink.size()-1)

	{
		for (int j= m_idxStart+m_size; j<pathLink.size(); ++j)
		{
			if (pathLink[j]!=0) //pathLink[start-1]
			{
				break;
			}

			if (pathLink[j]==0)
			{
				tailFit++;
			}

		}
		return tailFit;
	}
	 if(m_idxStart + m_size-1 >pathLink.size()-1)
	{
		cerr<< " error with Block parameters ";
		exit(1);
	}

}

Block::~Block(){}
